package test.sort;

import com.rp.util.test.RandomArrayGenerator;
import com.rp.util.sort.*;
import test.util.ArrayPrint;
import test.sort.IObject;
import test.sort.IObjectCompare;
import com.rp.util.sort.compare.IntegerComparator;
import com.rp.util.sort.*;
import timer.ITimer;

import java.util.List;
import java.util.ArrayList;

public class SortTime
{
	private ISort sort = null;
	private RandomArrayGenerator rd = null;
	private ITimer timer = null;

	public SortTime (ISort sort, ITimer timer)
	{
		this.sort = sort;	
		this.timer = timer;
		
		//warm up timer
		for (int i = 0; i < 2500; i++)
		{
			timer.start();
			timer.stop();
			timer.getTime();	
		}
	}
	
	public double sort (String type, int count)
	{
		if (type.equals("int"))
		{
			int[] arr = rd.getInt(count);
			timer.start();
			sort.sort(arr);
			timer.stop();
			return timer.getTime();
		}
		
		if (type.equals("String"))
		{
			String[] arr = rd.getString(count, 5);
			timer.start();
			sort.sort(arr);
			timer.stop();
			return timer.getTime();
		}
		
		if (type.equals("long"))
		{
			long[] arr = rd.getLong(count);
			timer.start();
			sort.sort(arr);
			timer.stop();
			return timer.getTime();
		}
		
		if (type.equals("short"))
		{
			short[] arr = rd.getShort(count);
			timer.start();
			sort.sort(arr);
			timer.stop();
			return timer.getTime();
		}
			
		if (type.equals("double"))
		{
			double[] arr = rd.getDouble(count);
			timer.start();
			sort.sort(arr);
			timer.stop();
			return timer.getTime();
		}
		
		if (type.equals("float"))
		{
			float[] arr = rd.getFloat(count);
			timer.start();
			sort.sort(arr);
			timer.stop();
			return timer.getTime();
		}
		
		if (type.equals("char"))
		{
			char[] arr = rd.getChar(count);
			timer.start();
			sort.sort(arr);
			timer.stop();
			return timer.getTime();
		}
		
		if (type.equals("byte"))
		{
			byte[] arr = rd.getByte(count);
			timer.start();
			sort.sort(arr);
			timer.stop();
			return timer.getTime();
		}
		
		if (type.equals("Object"))
		{
			try
			{
				int[] intVals = RandomArrayGenerator.getInt (count);
				int len = intVals.length;
				IntegerComparator icomp = new IntegerComparator();
				IObject[] arr = new IObject[len];		
				for (int i = 0; i < len; i++)
				{	
					IObject ione = new IObject();
					ione.setData (new Integer(intVals[i]));
					arr[i] = ione;
				}
				timer.start();
				sort.sort (arr, icomp, "getData");
				timer.stop();
				return timer.getTime();
			}
			catch (Exception e)
			{
				System.out.println ("EXCEPTION: " +e.toString());
			}	
		}
		
		if (type.equals("ObjectC"))
		{
			try
			{
				int[] intVals = RandomArrayGenerator.getInt (count);
				int len = intVals.length;
				IObject[] arr = new IObject[len];		
				IObjectCompare io = new IObjectCompare();
				for (int i = 0; i < len; i++)
				{	
					IObject ione = new IObject();
					ione.setData (new Integer(intVals[i]));
					arr[i] = ione;
				}
				timer.start();
				sort.sort (arr, io);
				timer.stop();
				return timer.getTime();
			}
			catch (Exception e)
			{
				System.out.println ("EXCEPTION: " +e.toString());
			}	
		}
		
		if (type.equals("List"))
		{
			try
			{
				int[] intVals = RandomArrayGenerator.getInt (count);
				int len = intVals.length;
				List arr = new ArrayList(len);
				IObjectCompare io = new IObjectCompare();
				for (int i = 0; i < len; i++)
				{
					IObject ione = new IObject();
					ione.setData (new Integer(intVals[i]));
					arr.add(ione);	
				}
				
				timer.start();
				sort.sort (arr, io);
				timer.stop();
				return timer.getTime();
			}
			catch (Exception e)
			{
				System.out.println ("EXCEPTION: " +e.toString());
			}	
		}
		return -1.0;
	}
}